/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ITelemetryBaseLogger } from "@fluidframework/core-interfaces";
import { IBatch } from "./definitions.js";
/**
 * Compresses batches of ops. It generates a single compressed op that contains
 * the contents of each op in the batch. It then submits empty ops for each original
 * op to reserve sequence numbers.
 */
export declare class OpCompressor {
    private readonly logger;
    constructor(logger: ITelemetryBaseLogger);
    compressBatch(batch: IBatch): IBatch;
    private serializeBatch;
}
//# sourceMappingURL=opCompressor.d.ts.map